

--[[
need to add a method of making the open window refresh itself
--]]

local tinsert = table.insert

local topbar = CreateFrame("Frame", UIParent)
			topbar:SetSize(256,16)
			
			topbar.tex = topbar:CreateTexture()
			topbar.tex:SetTexture("Textures/topbar.png")
			topbar.tex:SetColor({0,0,0,255})
			topbar.tex:SetSize(256,16)
			topbar.tex:SetTexCoord(0,1,0,1)
			
			topbar.File = CreateFrame("Button", topbar)
			topbar.File:SetText("File")
			topbar:SetScript("OnEnter", function() print("cheese") end)
			
	function topbar.GetX(self)
		return self.x
	end
	
	function topbar.GetY(self)
		return self.y
	end
	
	function topbar.GetScaleX(self)
		return self.scalex
	end
	
	function topbar.GetScaleY(self)
		return self.scaley
	end
local FileSystem = CreateFrame("Frame", UIParent)
			
local FileMenu = CreateFrame("Frame", topbar)			
			FileMenu:Hide()
			
			topbar:SetScript("OnMouseDown", function(self)
																			if self.open then
																				FileMenu:Hide()
																				self.open = false
																			else
																				FileMenu:Show()
																				self.open = true
																			end
																		end)
			
			
			FileMenu:SetPoint(5,16)
			
			FileMenu.NewFile = CreateFrame("Button", FileMenu)
			FileMenu.NewFile:SetText("New Project")
			FileMenu.NewFile:SetSize(60, 16)
			FileMenu.NewFile:SetScript("OnMouseDown", function(self) CreateFrame("Project", UIParent) end)
			
			FileMenu.OpenFile = CreateFrame("Button", FileMenu)
			FileMenu.OpenFile:SetText("Open Project")
			FileMenu.OpenFile:SetSize(60, 16)			
			FileMenu.OpenFile:SetPoint(0,16)
			FileMenu.OpenFile:SetScript("OnMouseDown", function() FileSystem:Show() end)
			

FileSystem:SetBackdrop("Textures/template.png", 32)
FileSystem:SetSize(300, 220)
FileSystem:UpdateBackdrop()
FileSystem:SetPoint(100,100)
FileSystem:SetScript("OnMouseDown", function(self) self:StartMoving() end)
FileSystem:SetScript("OnMouseUp", function(self) self:StopMovingOrSizing() end)
FileSystem.title = FileSystem:CreateFontString("DEJAVUSANSMONO.TTF", 10)
FileSystem.title:SetColor({255,255,255,255})
FileSystem.title:SetText("Open")
FileSystem.title:SetPoint(28,20)
FileSystem.lines = {}
FileSystem:Hide()

local offset = 0

local dir = "/Projects"
local t = love.filesystem.enumerate(dir)

local i  = 0

local function LoadProj(name, subfiles)
local p = CreateFrame("Project", UIParent)
	p:SetPoint(#Projects*100, 100)
	p.title:SetText(name)
	local main = love.filesystem.read("Projects/"..name.."/main.lua")
		
	if main then
		global,body = main:match("%-%-==+ GLOBALS =+\n(.-)%-%-=+(.+)")
	end
	if global then p.globals:SetText(global) end
	
	if main then p.main:SetText(body) end
	
	for _,f in pairs(t) do
		
	end
end

for i = 1, 10 do
	local temp = CreateFrame("Frame", FileSystem)
				temp:SetPoint(30,15*i+25)
				temp:SetSize(180, 15)
				temp.label = temp:CreateFontString("DEJAVUSANSMONO.TTF", 10)
		
		temp.label:SetText("Test")
		temp.label:SetColor({180,180,255,255})
	temp:SetScript("OnMouseDown", function(self,x,y,button)
																	
																	if button == "wu" then
																		offset = math.max(0,(offset -1))
																	elseif button == "wd" then
																		offset = math.min(#t+2-10,(offset +1))
																	else
																		local msg = self.label:GetText()
																		if not msg:find("%w+%.%w+") then
																			
																			dir = dir..msg.."/"
																			t = love.filesystem.enumerate(dir)
																			LoadProj(msg, t)
																			
																		end
																	end
																	
																	

																			
																		end)
	tinsert(FileSystem.lines, temp)
end

for i = 1, 5 do
--	love.filesystem.mkdir("testdir"..i)
end



for _,f in pairs(t) do
	if f then
		i = i + 1
		if FileSystem.lines[i] then
			FileSystem.lines[i].label:SetText(f)
		end
	end
end



FileSystem:SetScript("OnMouseDown", function(self,x,y,button)
																			for i = 1, #FileSystem.lines do
																				FileSystem.lines[i].label:SetText("")
																			end
																			

																			if button == "wu" then
																				offset = math.max(0,(offset -1))
																			elseif button == "wd" then
																				offset = math.min(#t+2-10,(offset +1))
																			end
																			for i = 1, #t do
																				if FileSystem.lines[i] then
																					FileSystem.lines[i].label:SetText(t[i+offset])
																				end
																			end

																			
																		end)
--FileSystem:Hide()



			
			
			